#include <iostream>
#include <vector>

using namespace std;

extern vector<long long> fly(int H, vector<int> A, vector<int> B, vector<int> L, vector<int> R);

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int N, H;
	cin >> N >> H;
	
	vector<int> A(N), B(N), L(N), R(N);

	for (int i = 0; i < N; i++) {
		cin >> A[i];
	}

	for (int i = 0; i < N; i++) {
		cin >> B[i];
	}

	for (int i = 0; i < N; i++) {
		cin >> L[i];
	}

	for (int i = 0; i < N; i++) {
		cin >> R[i];
	}

	vector<long long> T = fly(H, A, B, L, R);

	for (int i = 0; i < (int)T.size(); i++) {
		cout << T[i] << (i + 1 < (int)T.size() ? ' ' : '\n');
	}
}
